/** 
 *  Hyper Operating System  Application Framework
 *
 * @file  assoc_removenode.c
 * @brief %jp{Ϣ󥯥饹}
 *
 * Copyright (C) 2006-2009 by Project HOS
 * http://sourceforge.jp/projects/hos/
 */

#include <stdio.h>
#include <string.h>
#include "hosaplfw.h"
#include "assoc_local.h"



/* ƥΡɤ³񤭴 */
static void Assoc_SetParentLink(C_ASSOC *self, T_ASSOC_NODE *pNode, T_ASSOC_NODE *pNewNode)
{
	if ( pNode->pParent == NULL )
	{
		self->pRoot = pNewNode;
	}
	else
	{
		if ( pNode->pParent->pLeft == pNode )
		{
			pNode->pParent->pLeft = pNewNode;
		}
		else
		{
			pNode->pParent->pRight = pNewNode;
		}
	}
}

/* Ρɺ */
void Assoc_RemoveNode(C_ASSOC *self, T_ASSOC_NODE *pNode)
{
	T_ASSOC_NODE *pReplaceNode;
	
	
	if ( pNode->pLeft != NULL && pNode->pRight != NULL )	/* ξ */
	{
		/* ξ */
		pReplaceNode = Assoc_GetMinNode(pNode->pRight);
		Assoc_SetParentLink(self, pReplaceNode, NULL);
		pReplaceNode->pParent = pNode->pParent;
		pReplaceNode->pLeft   = pNode->pLeft;
		pReplaceNode->pRight  = pNode->pRight;
		Assoc_SetParentLink(self, pReplaceNode, pReplaceNode);
		if ( pReplaceNode->pLeft  != NULL ) { pReplaceNode->pLeft->pParent  = pReplaceNode; }
		if ( pReplaceNode->pRight != NULL ) { pReplaceNode->pRight->pParent = pReplaceNode; }
	}
	else if ( pNode->pLeft != NULL )
	{
		/* Τ */
		Assoc_SetParentLink(self, pNode, pNode->pLeft);
	}
	else if ( pNode->pRight != NULL )
	{
		/* Τ */
		Assoc_SetParentLink(self, pNode, pNode->pRight);
	}
	else
	{
		/* ̵ */
		Assoc_SetParentLink(self, pNode, NULL);
	}
	
	/* 곫 */
	MemHeap_Free(self->pMemHeap, pNode);
}


/* end of file */
