/** 
 *  Sample program for Hyper Operating System V4 Advance
 *
 * @file  sample.c
 * @brief %jp{ץץ}%en{Sample program}
 *
 * Copyright (C) 1998-2006 by Project HOS
 * http://sourceforge.jp/projects/hos/
 */


#include <stdio.h>
#include <stdlib.h>
#include "kernel.h"
#include "kernel_id.h"
#include "hosaplfw.h"
#include "system/system/system.h"
#include "system/sysapi/sysapi.h"
#include "system/file/console.h"
#include "system/process/process.h"
#include "system/command/command.h"
#include "system/shell/shell.h"
#include "driver/console/vt100/vt100drv.h"
#include "driver/serial/renesas/scidrv.h"
#include "application/example/hello/hello.h"
#include "application/utility/memdump/memdump.h"


#define SYSCR		((volatile unsigned char *)0xfee012)
#define IPRB		((volatile unsigned char *)0xfee019)



void Sample_Startup(VP_INT exinf)
{
	HANDLE	hTty;
	HANDLE	hCon;
	HANDLE	hDriver;
	
	/*************************/
	/*       ͭ        */
	/*************************/
	*SYSCR &= ~0x08;		/* UIӥåȤߥޥ˻Ȥ */
	*IPRB  |=  0x0e;		/* SCI1γͥ٤夲 */
	
	
	/*************************/
	/*                 */
	/*************************/
	
	/* ƥ */
	System_Initialize((void *)0x00500000, 0x00100000);
	
	
	/*************************/
	/*     ǥХɥϿ      */
	/*************************/
	
	/* SCI0  /dev/com0 Ͽ */
	hDriver = SciDrv_Create((void *)0xffffb0, 52, 20000000L, 64);	/* SCI0 */
	SysFile_AddDevice("com0", hDriver);
	
	/* SCI1  /dev/com1 Ͽ */
	hDriver = SciDrv_Create((void *)0xffffb8, 56, 20000000L, 64);	/* SCI1 */
	SysFile_AddDevice("com1", hDriver);
	
	
	/* ꥢ򳫤 */
	hTty = File_Open("/dev/com1", FILE_OPEN_READ | FILE_OPEN_WRITE);
	
	/* ꥢ˥󥽡( /dev/con1 Ͽ) */
	hDriver = Vt100Drv_Create(hTty);
	File_AddDevice("con1", hDriver);
	
	/* 󥽡򳫤 */
	hCon = File_Open("/dev/con1", FILE_OPEN_READ | FILE_OPEN_WRITE);
	
	
	
	/*************************/
	/*     ޥϿ      */
	/*************************/
	Command_AddCommand("hsh",     Shell_Main);		/* Ͽ */
	Command_AddCommand("hello",   Hello_Main);		/* Hello World Ͽ */
	Command_AddCommand("memdump", MemDump_Main);
	
	
	
	/*************************/
	/*  ƥץư */
	/*************************/
	System_Boot(hTty, hCon, "hsh", 4096);
}



/* end of file */
