/** 
 *  Hyper Operating System V4 Advance
 *
 * @file  rdq.h
 * @brief %jp{ǥ塼֥ȤΥإåե}%en{ready-queue object heder file}
 *
 * Copyright (C) 1998-2008 by Project HOS
 * http://sourceforge.jp/projects/hos/
 */



#ifndef __HOS_V4a__knl_rdq_h__
#define __HOS_V4a__knl_rdq_h__


#if _KERNEL_RDQ_ALGORITHM == _KERNEL_RDQ_ALG_SINGLE_QUE


/* ------------------------------------------ */
/*             single queue                   */
/* ------------------------------------------ */


/** %en{ready-queue control block}%jp{ǥ塼֥å} */
typedef struct _kernel_t_rdqcb
{
	_KERNEL_T_QUE	que;
} _KERNEL_T_RDQCB;


#define _KERNEL_CRE_RDQ(rdqcb)			_KERNEL_CRE_QUE(&(rdqcb)->que)				/**< %en{create ready-queue}%jp{ǥ塼} */
#define _KERNEL_DEL_RDQ(rdqcb)			_KERNEL_DEL_QUE(&(rdqcb)->que)				/**< %en{delete ready-queue}%jp{ǥ塼κ} */

#define _KERNEL_ADD_RDQ(rdqcb, tskhdl)	_KERNEL_ADP_QUE(&(rdqcb)->que, (tskhdl))	/**< %jp{ǥ塼ɲ} */
#define _KERNEL_RMV_RDQ(rdqcb, tskhdl)	_KERNEL_RMV_QUE(&(rdqcb)->que, (tskhdl))	/**< %jp{ǥ곰} */

#define _KERNEL_RMH_RDQ(rdqcb)			_KERNEL_RMH_QUE(&(rdqcb)->que)				/**< %jp{塼Ƭμ곰} */
#define _KERNEL_REF_RDQ(rdqcb)			_KERNEL_REF_QUE(&(rdqcb)->que)				/**< %jp{塼Ƭλ} */

#define _KERNEL_ROT_RDQ(rdqcb, tskpri)	_KERNEL_RTP_QUE(&(rdqcb)->que, (tskpri))	/**< %jp{ǥ塼βž} */


#elif _KERNEL_RDQ_ALGORITHM == _KERNEL_RDQ_ALG_ARRAYED_QUE

/* ------------------------------------------ */
/*               arrayed que                  */
/* ------------------------------------------ */

/** %en{ready-queue control block}%jp{ǥ塼֥å} */
typedef struct _kernel_t_rdqcb
{
	_KERNEL_T_QUE	que[_KERNEL_TSK_TMAX_TPRI];
} _KERNEL_T_RDQCB;


#define _KERNEL_CRE_RDQ(rdqcb)			_kernel_cre_rdq((rdqcb))					/**< %jp{ǥ塼}%en{create ready-queue} */
#define _KERNEL_DEL_RDQ(rdqcb)			_kernel_del_rdq((rdqcb))					/**< %jp{ǥ塼κ}%en{delete ready-queue} */

#define _KERNEL_ADD_RDQ(rdqcb, tskhdl)	_kernel_add_rdq((rdqcb), (tskhdl))			/**< %jp{ǥ塼ɲ} */
#define _KERNEL_RMV_RDQ(rdqcb, tskhdl)	_kernel_rmv_rdq((rdqcb), (tskhdl))			/**< %jp{ǥ곰} */

#define _KERNEL_RMH_RDQ(rdqcb)			_kernel_rmh_rdq((rdqcb))					/**< %jp{塼Ƭμ곰} */
#define _KERNEL_REF_RDQ(rdqcb)			_kernel_ref_rdq((rdqcb))					/**< %jp{塼Ƭλ} */

#define _KERNEL_ROT_RDQ(rdqcb, tskpri)	_kernel_rot_rdq((rdqcb), (tskpri))			/**< %jp{ǥ塼βž} */


#ifdef __cplusplus
extern "C" {
#endif

void             _kernel_cre_rdq(_KERNEL_T_RDQCB *rdqcb);							/**< %jp{ǥ塼}%en{create ready-queue} */
void             _kernel_del_rdq(_KERNEL_T_RDQCB *rdqcb);							/**< %jp{ǥ塼κ}%en{delete ready-queue} */

void             _kernel_add_rdq(_KERNEL_T_RDQCB *rdqcb, _KERNEL_T_TSKHDL tskhdl);	/**< %jp{ǥ塼ɲ} */
void             _kernel_rmv_rdq(_KERNEL_T_RDQCB *rdqcb, _KERNEL_T_TSKHDL tskhdl);	/**< %jp{ǥ塼곰} */

_KERNEL_T_TSKHDL _kernel_rmh_rdq(_KERNEL_T_RDQCB *rdqcb);							/**< %jp{ǥ塼Ƭμ곰} */
_KERNEL_T_TSKHDL _kernel_ref_rdq(_KERNEL_T_RDQCB *rdqcb);							/**< %jp{ǥ塼Ƭλ} */

void             _kernel_rot_rdq(_KERNEL_T_RDQCB *rdqcb, PRI tskpri);				/**< %jp{ǥ塼βž} */

#ifdef __cplusplus
}
#endif



#else	/* error */

#error Illegal value : _KERNEL_QUE_ALGORITHM

#endif



#endif	/* __HOS_V4a__knl_que_h__ */



/* end of file */
