/** 
 *  Hyper Operating System V4 Advance
 *
 * @file  rcv_adtq.c
 * @brief %jp{Ʊǡ塼}%en{Receive from Asynchronous Data Queue}
 *
 * Copyright (C) 1998-2006 by Project HOS
 * http://sourceforge.jp/projects/hos/
 */


#include "core/core.h"
#include "core/adtq.h"



BOOL _kernel_adtq_rcv_dat(_KERNEL_T_ADTQCB *adtqcb, VP_INT *p_data)
{
	_KERNEL_ADTQ_T_POSITION head;
	VP_INT                  *adtq;

	/* %jp{Ƭּ} */
	head = _KERNEL_ADTQ_GET_HEAD(adtqcb);

	/* %jp{ǡå} */
	if ( head == _KERNEL_ADTQ_GET_TAIL(adtqcb) )
	{
		return FALSE;	/* %jp{ǡ̵} */
	}

	/* %jp{ǡФ} */
	adtq = _KERNEL_ADTQ_GET_ADTQ(adtqcb);
	*p_data = adtq[head];

	/* %jp{ַ׻} */
	if ( head < _KERNEL_ADTQ_GET_ADTQCNT(adtqcb) - 1 )
	{
		head++;
	}
	else
	{
		head = 0;
	}

	/* %jp{Ƭֹ} */
	_KERNEL_ADTQ_SET_HEAD(adtqcb, head);
	
	return TRUE;
}


/* end of file */
