/** 
 *  Hyper Operating System V4 Advance
 *
 * @file  sig_mbx.c
 * @brief %jp{᡼ܥå񸻤ֵ}%en{Release Semaphore Resource}
 *
 * Copyright (C) 1998-2006 by Project HOS
 * http://sourceforge.jp/projects/hos/
 */


#include "core/core.h"
#include "object/mbxobj.h"


#if _KERNEL_SPT_RCV_MBX

/**< %jp{᡼ܥåؤ} */
ER rcv_mbx(ID mbxid, T_MSG **ppk_msg)
{
	_KERNEL_T_MBXCB_PTR mbxcb;
	_KERNEL_T_TSKHDL    tskhdl;
	_KERNEL_T_TCB       *tcb;
	T_MSG               *pk_msg;
	ER                  ercd;

	/* %jp{ID Υå} */
#if _KERNEL_SPT_RCV_MBX_E_ID
	if ( !_KERNEL_MBX_CHECK_MBXID(mbxid) )
	{
		return E_ID;	/* %jp{IDֹ}%en{Invalid ID number} */
	}
#endif
	
	_KERNEL_ENTER_SVC();	/* %jp{ӥ}%en{enter service-call} */
	
	/* %jp{֥¸ߥå} */
#if _KERNEL_SPT_RCV_MBX_E_NOEXS
	if ( !_KERNEL_MBX_CHECK_EXS(mbxid) )
	{
		_KERNEL_LEAVE_SVC();	/* %jp{ӥ뽪λ} */
		return E_NOEXS;			/* %jp{֥̤} */
	}
#endif
	
	/* %jp{ȥ֥å} */
	mbxcb = _KERNEL_MBX_ID2MBXCB(mbxid);
	
	/* %jp{å塼Ф} */
	pk_msg = _KERNEL_MBX_RMV_MSG(mbxcb, _KERNEL_MBX_GET_MBXCB_RO(mbxid, mbxcb));

	if ( pk_msg != NULL )
	{
		*ppk_msg = pk_msg;
		ercd     = E_OK;
	}
	else
	{
		/* %jp{Ԥ֤ˤ} */
		tskhdl = _KERNEL_SYS_GET_RUNTSK();
		tcb    = _KERNEL_TSK_TSKHDL2TCB(tskhdl);			/* %jp{TCB} */

		_KERNEL_TSK_SET_TSKWAIT(tcb, _KERNEL_TTW_SEM);
		_KERNEL_TSK_SET_WOBJID(tcb, mbxid);
		_KERNEL_TSK_SET_DATA(tcb, (VP_INT)ppk_msg);
		
		_KERNEL_DSP_WAI_TSK(tskhdl);
		_KERNEL_MBX_ADD_QUE(mbxcb, _KERNEL_MBX_GET_MBXCB_RO(flgid, mbxcb), tskhdl);		/* %jp{Ԥɲ} */
		
		/* %jp{ǥѥåμ¹} */
		_KERNEL_DSP_TSK();

		/* %jp{顼ɤμ} */
		ercd = _KERNEL_TSK_GET_ERCD(tcb);
	}
	
	_KERNEL_LEAVE_SVC();	/* %jp{ӥ뤫Ф}%en{leave service-call} */
	
	return ercd;
}


#else	/* _KERNEL_SPT_RCV_MBX */


#if _KERNEL_SPT_RCV_MBX_E_NOSPT


ER rcv_mbx(ID mbxid)
{
	return E_NOSPT;
}

#endif


#endif	/* _KERNEL_SPT_RCV_MBX */



/* end of file */
